{
  Escreva um procedimento Inverte, em Pascal, que receba como entrada um
  apontador P para o primeiro elemento de uma lista e retorne P apontando
  para esta lista invertida.
}

program InverteListaEncadeada;
(* Faz com que um ponteiro que aponta para o primeiro no de uma lista *)
(* encadeada (criada pelo programa), passe a apontar para esta lista  *)
(* invertida                                                          *)

const
   NUMERO_DE_NOS = 6;
type
   tString = string[30];
   tArranjo = array [1..NUMERO_DE_NOS] of tString;
   tApontador = ^no;
   no = record
              nome : tString;
              proximo : tApontador
        end;
var
    cabeca, ptrDesaloca : tApontador;
    i : integer;

procedure CriaLista(var lista : tApontador);
(* Cria uma lista encadeada *)

var
   i : integer;
   ptrAuxiliar, noNovo : tApontador;

begin
   writeln('Introduza ',NUMERO_DE_NOS,' palavras :');
   new(lista);
   (* Leitura do conteudo do primeiro no da lista *)
   readln(lista^.nome);
   ptrAuxiliar:=lista; (* ptrAuxiliar passa a apontar para a mesma posicao *)
                       (* de memoria apontada por lista, desse modo a      *)
                       (* cabeca da lista nao se "perde"                   *)

   for i := 2 to NUMERO_DE_NOS do begin
       new(noNovo); (* Criacao de um novo no *)
       readln(noNovo^.nome); (* Preenchemento do no *)
       ptrAuxiliar^.proximo := noNovo; (* Encadea o novo no com o anterior *)

       ptrAuxiliar := noNovo (* ptrAuxiliar, que estava apontando para o    *)
                             (* primeiro no, passa a apontar para o novo no *)
   end;
   ptrAuxiliar^.proximo := nil; (* Atribui o valor "nil" ao campo "proximo" *)
                                (* do ultimo no da lista criada             *)
end; (* CriaLista *)

procedure Inverte(var lista : tApontador);
(* Faz com que um ponteiro que aponta para o primeiro no de uma lista *)
(* encadeada, passe a apontar para esta lista invertida               *)

var
   arranjoAuxiliar : tArranjo;
   ptrAuxiliar1, ptrAuxiliar2 : tApontador;
   i : integer;

begin
   ptrAuxiliar1 := lista; (* ptrAuxiliar1 passa a apontar para a mesma posicao  *)
                          (* de memoria apontada por lista, desse modo a cabeca *)
                          (* da lista nao se "perde"                            *)

   while (ptrAuxiliar1 <> nil) do begin
       (* Armazena os valores do campo "nome" dos nos da lista encadeada *)
       (* em um arranjo                                                  *)
       for i := 1 to NUMERO_DE_NOS do begin
           arranjoAuxiliar[i] := ptrAuxiliar1^.nome;
           ptrAuxiliar1 := ptrAuxiliar1^.proximo;
       end;
   end;

   ptrAuxiliar2 := lista;

   (* Atribuicao dos valores que estao no arranjo ao campo "nome" dos nos da *)
   (* lista encadeada, so que os valores sao atribuidos a partir do ultimo   *)
   (* elemento, indo ate o primeiro                                          *)
   while (ptrAuxiliar2 <> nil) do begin
       for i := NUMERO_DE_NOS downto 1 do begin
           ptrAuxiliar2^.nome := arranjoAuxiliar[i];
           ptrAuxiliar2:=ptrAuxiliar2^.proximo; (* ptrAuxiliar2 passa a apontar *)
                                                (* para o proximo no da lista   *)
       end;
   end;
end; (* Inverte *)

begin
   CriaLista(cabeca);
   Inverte(cabeca);

   (* Impressao e desalocacao da lista encadeada apos a inversao *)
   writeln('A lista inicial apos ser invertida eh :');
   while (cabeca <> nil) do begin
       writeln(cabeca^.nome);
       ptrDesaloca:=cabeca; (* Atribuicao do ponteiro, cujo campo "nome" *)
                            (* foi impresso, ao ponteiro ptrDesaloca     *)
       cabeca:=cabeca^.proximo;
       dispose(ptrDesaloca); (* Liberacao do espaco ocupado por ptrDesaloca *)
   end;
end.


















