{
  Uma empresa tem uma lista de registros de empregados cada um contendo os
  seguintes componentes:

  nome (string);
  idade (valor inteiro);
  salario (valor real);
  sexo ('M' ou 'F');

  Faca um programa que leia esta lista de registros e imprima todas as
  informacoes a respeito da funcionaria mais e menos remunerada, do
  funcionario mais e menos remunerado e a media dos salarios dos funcionarios
  e funcionarias.
}

program ListaDeEmpregados2;
(* Imprime todas as informacoes a respeito da funcionaria mais e menos remunerada, *)
(* do funcionario mais e menos remunerado e a media dos salarios dos funcionarios  *)
(* e funcionarias                                                                  *)

const
   EMPREGADOS = 70;
   MAX_DE_CARACT = 80;
type
   tNome = string[MAX_DE_CARACT];
   tIdade = 1..70;
   tRegistrodeEmpregado = record
                                nome : tNome;
                                sexo : char;
                                idade : tIdade;
                                salario : real;
                          end;
   tEmpregado = array [1..EMPREGADOS] of tRegistroDeEmpregado;
var
   empregado : tEmpregado;
   i, numeroDeEmpregados, indice1, indice2, indiceMaior, indiceMenor : integer;
   mediaMasc, mediaFem : real;

procedure LeRegistro(var empresa : tEmpregado; pessoas : integer);
(* Le o registro que contem os dados do empregado *)

var
   k : integer;

begin
   for k := 1 to pessoas do
       with empresa[k] do begin
           (* Leitura do nome do(a) empregado(a) *)
           writeln('Digite o nome do(a) funcionario(a) :');
           readln(nome);
           (* Leitura do sexo do(a) empregado(a) *)
           writeln('Digite o sexo (M/F) de ',nome,' :');
           readln(sexo);
           (* Le novamente o sexo do(a) empregado(a) caso o sexo anterior *)
           (* seja diferente de "M" e "F"                                 *)
           while ((sexo <> 'M') and (sexo <> 'F')) do begin
               writeln('Erro.Digite "M" (masculino) ou "F" (feminino) :');
               readln(sexo);
           end;
           (* Leitura da idade do(a) empregado(a) *)
           writeln('Digite a idade de ',nome,' :');
           readln(idade);
           (* Leitura da idade do(a) empregado(a) *)
           writeln('Digite o salario de ',nome,' (em reais) :');
           readln(salario);
       end;
end; (* LeRegistro *)

procedure MulherMaisEMenosRemunerada(var empresa : tEmpregado; pessoas, ind : integer; var indMa, indMe : integer);
(* Verifica qual a empregada mais e menos remunerada da empresa *)

var
   k : integer;
   maiorSalario, menorSalario : real;

begin
   (* Considera-se que a empregada mais remunerada eh a primeira a ser  *)
   (* encontrada no arranjo                                             *)
   maiorSalario := empresa[indMa].salario; (* Inicializacao com o  *)
                                           (* salario da primeira  *)
                                           (* empregada localizada *)

   (* Armazena o indice da empregada mais remunerada *)
   indMa := ind;

   (* Considera-se que a empregada menos remunerada eh a primeira a ser  *)
   (* encontrada no arranjo                                              *)
   menorSalario := empresa[ind].salario; (* Inicializacao com o  *)
                                         (* salario da primeira  *)
                                         (* empregada localizada *)

   (* Armazena o indice da mulher mais remunerada *)
   indMe := ind;

   (* Verifica se ha outras empregadas e se o seu salario eh maior ou menor *)
   for k := (ind+1) to pessoas do
       with empresa[k] do
           if (sexo = 'F') then
               (* Verifica se o salario da outra empregada eh maior que o *)
               (* da primeira                                             *)
               if (salario > maiorSalario) then begin
                   maiorSalario := salario; (* Armazena o maior salario *)

                   indMa := k; (* Guarda o indice do arranjo que       *)
                               (* corresponde ao indice da empregada   *)
                               (* mais remunerada                      *)
               end
                (* Verifica se o salario da outra empregada eh menor que o *)
                (* da primeira                                             *)
           else if(salario < menorSalario) then begin
                    menorSalario := salario; (* Armazena o menor salario *)

                    indMe := k; (* Guarda o indice do arranjo que        *)
                                (* corresponde ao indice da mulher menos *)
                                (* remunerada                            *)
                end;
end; (* MulherMaisEMenosRemunerada *)

procedure HomemMaisEMenosRemunerado(var empresa : tEmpregado; pessoas, ind : integer; var indMa, indMe : integer);
(* Verifica qual o empregado mais e menos remunerado da empresa *)

var
   k : integer;
   maiorSalario, menorSalario : real;

begin
   (* Considera-se que o empregado mais remunerado eh o primeiro a ser  *)
   (* encontrado no arranjo                                             *)
   maiorSalario := empresa[ind].salario; (* Inicializacao com o  *)
                                         (* salario do primeiro  *)
                                         (* empregado localizado *)

   (* Armazena o indice do empregado mais remunerado *)
   indMa := ind;

   (* Considera-se que o empregado menos remunerado eh o primeiro a ser  *)
   (* encontrado no arranjo                                              *)
   menorSalario := empresa[ind].salario;

   (* Armazena o indice do empregado menos remunerado *)
   indMe := ind;

   (* Verifica se ha outros empregados e se o seu salario eh maior ou menor *)
   for k := (ind+1) to pessoas do
       with empresa[k] do
           if (sexo = 'M') then
               (* Verifica se o salario do outro empregado eh maior que o *)
               (* do primeiro                                             *)
               if (salario > maiorSalario) then begin
                   maiorSalario := salario; (* Armazena o maior salario *)

                   indMa := k; (* Guarda o indice do arranjo que       *)
                               (* corresponde ao indice do empregado   *)
                               (* mais remunerado                      *)
               end
                (* Verifica se o salario do outro empregado eh menor que o *)
                (* do primeiro                                             *)
           else if (salario < menorSalario) then begin
                    menorSalario := salario; (* Armazena o menor salario *)

                    indMe := k; (* Guarda o indice do arranjo que       *)
                                (* corresponde ao indice do empregado   *)
                                (* menos remunerado                      *)
                end;
end; (* HomemMaisEMenosRemunerado *)

function MediaMulher(var empresa : tEmpregado; pessoas : integer; var mediaF : real) : real;
(* Calcula a media dos salarios das empregadas *)

var
   k, contadorF : integer;

begin
   mediaF := 0; (* Inicializa a media com 0 *)
   contadorF := 0; (* Inicializa o numero de empregadas com 0 *)

   for k := 1 to pessoas do
       with empresa[k] do
           if (sexo = 'F') then begin
               mediaF := mediaF + salario; (* Acumula a soma dos salarios *)
               contadorF := contadorF + 1; (* Incrementa-se o numero de   *)
                                           (* empregadas                  *)
           end;

   if (contadorF > 0) then (* Se o numero de empregadas for maior que 0 *)
                           (* calcula-se a media dos salarios           *)

       mediaF := mediaF/contadorF; (* A media eh calculada *)

   MediaMulher := mediaF;
end; (* MediaMulher *)

function MediaHomem(var empresa : tEmpregado; pessoas : integer; var mediaM : real) : real;
(* Calcula a media dos salarios dos empregados *)

var
   k, contadorM : integer;

begin
   mediaM := 0; (* Inicializa a media com 0 *)
   contadorM := 0; (* Inicializa o numero de empregados com 0 *)

   for k := 1 to pessoas do
       with empresa[k] do
           if (sexo = 'M') then begin
               mediaM := mediaM + salario; (* Acumula a soma dos salarios *)
               contadorM := contadorM + 1;  (* Incrementa-se o numero de   *)
                                            (* empregados                  *)
           end;

   if (contadorM > 0) then (* Se o numero de empregados for maior que 0 *)
                           (* calcula-se a media dos salarios           *)

       mediaM := mediaM/contadorM; (* A media eh calculada *)

   MediaHomem := mediaM;
end; (* MediaHomem *)

procedure Escrita(var empresa : tEmpregado; indiceQualquer : integer);
(* Imprime os dados dos empregados *)

begin
   with empresa[indiceQualquer] do begin
       writeln('Nome : ',nome);
       writeln('Sexo : ',sexo);
       writeln('Idade : ',idade,' anos');
       writeln('Salario : R$ ',salario:8:2)
   end;
end;

begin
   (* Leitura do numero de empregados *)
   writeln('Introduza o numero de empregados :');
   readln(numeroDeEmpregados);

   (* Le novamente o numero de empregados, caso o numero anterior seja maior *)
   (* que o permitido                                                        *)
   while (numeroDeEmpregados > EMPREGADOS) do begin
       writeln('Erro.Digite um valor menor ou igual a ',EMPREGADOS,' :');
       readln(numerodeEmpregados);
   end;

   LeRegistro(empregado, numeroDeEmpregados);

   (* Localizacao, no arranjo, do indice da primeira empregada *)
   i := 0;
   if (i <= numeroDeEmpregados) then
       repeat begin
           i := i + 1; (* Incrementa-se o i *)
           if (empregado[i].sexo = 'F') then
               indice1 := i (* Armazena o indice da primeira empregada *)
           else
               indice1 := 0;
       end;
       (* O "repeat" eh encerrado quando eh localizado o indice da primeira *)
       (* empregada ou quando o "i" assumir um valor maior que o numero de  *)
       (* empregados existentes                                             *)
       until ((empregado[i].sexo = 'F') or (i > numeroDeEmpregados));

   if (indice1 > 0) then begin (* Testa se o indice encontrado eh *)
                               (* maior que 0                     *)

       (* Imprime os dados da funcionaria mais remunerada *)
       writeln;
       writeln('Dados da funcionaria mais remunerada :');
       MulherMaisEMenosRemunerada(empregado, numeroDeEmpregados, indice1, indiceMaior, indiceMenor);
       Escrita(empregado, indiceMaior);
       writeln;
       (* Imprime os dados da funcionaria menos remunerada *)
       writeln('Dados da funcionaria menos remunerada :');
       Escrita(empregado, indiceMenor);
       writeln;
       (* Imprime a media dos salrios das funcionarias *)
       writeln('Media dos salarios das funcionarias : R$ ',MediaMulher(empregado, numeroDeEmpregados, mediaFem):7:2);
       writeln;
   end
   else begin
       writeln;
       writeln ('A empresa nao contem funcionarias.');
       writeln;
   end;

   (* Localizacao, no arranjo, do indice do primeiro empregado *)
   i := 0;
   if (i <= numeroDeEmpregados) then
       repeat begin
           i := i + 1; (* Incrementa-se o i *)
           if (empregado[i].sexo = 'M') then
               indice2 := i (* Armazena o indice do primeiro empregado *)
           else
               indice2 := 0;
       end;
       (* O "repeat" eh encerrado quando eh localizado o indice da primeira *)
       (* empregada ou quando o "i" assumir um valor maior que o numero de  *)
       (* empregados existentes                                             *)
       until ((empregado[i].sexo = 'M') or (i > numeroDeEmpregados));

   if (indice2 > 0) then begin (* Testa se o indice encontrado eh *)
                               (* maior que 0                     *)

       (* Imprime os dados do funcionario mais remunerado *)
       writeln('Dados do funcionario mais remunerado :');
       HomemMaisEMenosRemunerado(empregado, numeroDeEmpregados, indice2, indiceMaior, indiceMenor);
       Escrita(empregado, indiceMaior);
       writeln;
       (* Imprime os dados do funcionario menos remunerado *)
       writeln('Dados do funcionario menos remunerado :');
       Escrita(empregado, indiceMenor);
       writeln;
       (* Imprime a media dos salarios dos funcionarios *)
       writeln('Media dos salarios dos funcionarios : R$ ',MediaHomem(empregado, numeroDeEmpregados, mediaMasc):7:2);
   end
   else
       writeln ('A empresa nao contem funcionarios.');
end.